                 Function FUMILIR(Hpar,Hexd,funct,Nit,CF,CH)
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(nq=10000)
	character*(*) hpar,CF,CH,hexd,hname*15
	dimension ar(4)
	allocatable Ai(:,:),exd(:,:)
	external funct

	fumilir=-1.
	open(999,file=Hpar,status='old',err=1)
	do i=1,100000
	 read(999,*,err=2,end=2,iostat=iostat) j,hname,ar
      enddo
2     Npar=i-1
      write(*,*) 'Npar=',Npar
	open(999,file=Hexd,status='old',err=3)
	read(999,*) Lexd, Nexd
      write(*,*) 'Lexd=',Lexd,'Nexd=', Nexd
      allocate(Ai(6,Npar),exd(Lexd,Nexd))
	js=1
	if(Nexd.gt.nq) then
	   n1=nexd/nq
	   n2=nexd-n1*nq
	   je=nq
         do i=1,n1
	      read(999,*,err=4,end=4) exd(1:Lexd,js:je)
	      js=js+nq
	      je=je+nq
         enddo
      endif
	if(js.le.nexd) read(999,*,err=4,end=4) exd(1:Lexd,js:nexd)
	close(999)
      fumilir=fumilim(Ai,Hpar,Npar,exd,Lexd,Nexd,funct,Nit,CF,CH)
	return
1     write(*,*)'Cannot Open Initial Parameters File ',Hpar
      return
3     write(*,*)'Cannot Open Experimental Points File ',Hexd
      return
4     write(*,*)'Wrong Experimental Points File ',Hexd
      write (*,'(99(3f10.3/))') exd
      return
	           end
        Function FUMILIM(Ai,Hname,Np,exd,Lexd,Nexd,funct,Nit,CF,CH)

!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007-2010

!--------------- Np(>0) - number of parameters, no upper restriction for this vaLue

!--------------- Ai: parameters array  Ai(Np,6) 
!--------------- Ai(i,1) initiaL/final vaLues of parameters before start of FUMILIM,
!---------------  (anaLog of common/A/A(100))
!--------------- Ai(i,2) Parameter errors (final) (anaLog of common/SIGMA/SIGMA(100))       
!--------------- Ai(i,3) Correlation factor (final) (anaLog of common/R/R(100))
!                   new definition is used, now it is maximum of pair correlations,
!--------------- Ai(i,4) Parameter step restrictin  (anaLog of common/PL/PL(100)),
!                parameter fixed, if Ai(i,4)<0d0, adjusted by FUMILIM, if Ai(i,4)=0d0 (recommended)
!--------------- Ai(i,5) Minimum aLLowed vaLue of Ai(i,1)        (anaLog of common/AL/AMN(100))       
!--------------- Ai(i,6) Maximum aLLowed vaLue of Ai(i,1)        (anaLog of common/AU/AMX(100))

!--------------- hname: names for parameters array (character*(1-15)), dimension array(Np),
!                 or name of file with initial data
!                 Lazy user can write  hisq=FUMILIM(Ai,'*',Np,exd,Lexd,Nexd,funct,Nit,CF,CH),
!                 what means: no parameters names 

!--------------- exd: experimentaL points array exd(Lexd,Nexd), no upper restriction for Nexd 

!--------------- funct(x,a,df): user's Function (shouLd be decLared as EXTERNAL in caLLing program,
!                where x(1:n) - arguments, a(1:Np) - fitted parameters, df(1:Np) - first derivatives,
!                user is free to define or not each df(i)
!                if funct(x,a,df) is Linear respectiveLy each a(i), user is free to define nothing in the Ai array,
!                and the task wiLL be soLved during 1 iteration (poLinomiaL fit, for exampLe)
!--------------- Nit: maximum aLLowed number of iteration

!--------------- CF: '-' - no output, '*' - screen output, other - output file name
!--------------- CH: 'a' - output theor values and chi^2 for all points to file Hname(1).apN, where N=0-9
!---------------     'b' - the same for "bad points" to Hname(1).bpN  
!---------------     'c' - theor curve to Hname(1).cuN
!---------------     'h' - chi^2-histogram to Hname(1).hiN
!---------------     'f' - full output for each iteration in CF, by default only 0 and last iteration
!---------------     any combination of these symbols in CH is possible

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp,ifrp1,mfix,mtrd
	character*(*) hname(Np),CF,CH,hnmin*15(Np),namfil*19
      aLLocatabLe mtrd(:,:),evset(:),hiset(:),alm(:,:,:)
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/nparfum/Npar,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	common/fuminput/hisqmax(4),n1,n2/fumirs/ie,namfil(5)
	common/fumoutput/hisq,iflend,iit,akappa,aLambd,nbad
	dimension g(Np),a(Np),da(Np),r(Np),sgm(Np),pL(Np),amn(Np),amx(Np)
	dimension ifrp(Np),ifrp1(Np),mfix(Np),icor(np),ami(Np)
	dimension exd(Lexd*Nexd),Ai(Np,6),z(np*(np+1)/2),z0(np*(np+1)/2)
	data eps/0.01d0/T/0.25/ientr/0/
      EXTERNAL funct

      if(np==2.and.CF.eq.'-') then
         fumiLim=fumi2par(Ai,exd,Lexd,nexd,funct,Nit)
	   return
      endif
	fumilim=-1.
	ientr=ientr+1
	ned1=nexd
	ned2=Lexd 
	nitc=abs(Nit)
	Npar=Np
	ip=-1
      IF(CF.ne.'-') then
	   iflend=ifumread(ientr,CF,CH,Ai,hname,hnmin)
	   if(iflend.ne.0) return
	endif    
	Nfrp=0
      Do i=1,npar
	   a(i)=Ai(i,1)
	   R(i)=0d0
	   pL(i)=Ai(i,4)
	   if(pL(i).Lt.0d0) then
	      mfix(i)=3
         eLse
		  mfix(i)=0
		  Nfrp=Nfrp+1
		  ifrp(Nfrp)=i
         endif
	   if(Ai(i,5).eq.0d0.and.Ai(i,6).eq.0d0) then
	      amn(i)=-1d37
	      amx(i)=1d37
         else 
	      amn(i)=Ai(i,5)
	      amx(i)=Ai(i,6)
         endif
      Enddo
      nzfr=Nfrp*(Nfrp+1)/2
	iflend=initfum(exd,a,amn,amx,ifrp,funct) !check user's errors, find sets
	IF(iflend.ne.0) return
	aLLocate(alm(nxb,ns,2))
	aLLocate(mtrd(Nfrp+1,ns),evset(ns),hiset(ns),stat=ier1)
	if((ier1).ne.0) then
	   write(ip,*) '*** Allocate memory (ns*np) failed'
	   iflend=6
	   return
      endif
      call fumderiv(a,exd,funct,ifrp,mtrd,pl,hnmin,amn,amx,alm)
      NN2=0
      hisqt=1d37
	oldhisq=1d37
	alamo=1d0
	DO ifit=0,nfit   ! Cycle with Different Restrictions for chi**2
      iflend=0
	ami=a
	if(ifit.ne.0) then
	   hisqt=hisq/ned1*hisqmax(ifit)
	   if(ip.gt.0) write(ip,'(//A11,i2,A23,f5.1,A26)')
     &' Selection', ifit,' of events with chi^2 <',hisqmax(ifit)
     &  ,'*<chi^2> from previous fit'
	endif
      Do iiter=0,nitc   !-----Start New Iteration
	   iit=iiter
         do nn1=1,10 !Back to previous param.in part after jump over extremum
	  caLL sgzm(exd,funct,z0,g,a,pl,amx,ifrp,mtrd,evset,hiset,alm)
	  if(iit.eq.0) hisqm=hisq
	      dhisq=hisq-oldhisq
            if(dhisq.lt.0d0) exit
	      if(nn1.gt.n1.or.iit.eq.0) exit
	      if(ip.gt.0) then
	         if(nn1.eq.1) write(ip,*) ' '
		     write(ip,"(3x,'Back to ',A36,1pe11.4)")
     *	     '0.75 of Parameter Increments, chi^2=',hisq
	      endif
            NN2=0
	      T1=T
            if(alambd.lt.1d-6) T1=1d0
		  alambd=alambd*T1
            do n=1,Nfrp
	         i=ifrp(n)
		     a(i)=a(i)-da(i)
	         if(nn1.lt.n1) then
                  PL(I)=PL(I)*T1
                  DA(I)=da(i)*T
                  A(I)=A(I)+da(i)
               endif
            enddo
         enddo    ! nn1=1,n1

      do  !------------------------ boundary check
      do  !------------------------ mgconv 

!--------REMOVE FROM Z CONTRIBUTION OF PARAMETERS, FIXED DUE TO BOUND OR INDEFINITE
         Nfrp1=0
         nn=0
	   k2=0
         do  n=1,Nfrp
	     i=ifrp(n)
	     mn=nn
	     nn=nn+n
           IF(Z0(nn).eq.0d0) then
		    mfix(i)=2
 		 ELSEIF(AMX(I).LE.A(I).AND.G(I).Lt.0.D0.or.
     & 	    A(I).LE.AMN(I).AND.G(I).gt.0.D0) then
              mfix(i)=1
           ENDIF
           IF(mfix(I).ne.0) cycLe
           Nfrp1=Nfrp1+1
	     ifrp1(Nfrp1)=i
           do m=1,n
	       mn=mn+1 
             if(mfix(ifrp(m)).ne.0) cycLe
		   k2=k2+1
             Z(K2)=Z0(mn)
           enddo
         enddo ! n=1,Nfrp
      
         indef=mgconvm(z,mfix,ifrp1)
	   if(indef.eq.0) exit  ! from mgconv cycLe
      enddo  !------------------------ mgconv 
!-------CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION FACTOR
        ALAMBD=1.D0
	  alams=0d0
        AKAPPA=0.d0
        AFIX=0.D0   
        memfix=0   
        ii1=0
        Do i1=1,Nfrp1
	     i1L1=ii1
	     ii1=ii1+i1
	     i=ifrp1(i1)
	     sgm(i)=sqrt(Z(ii1))
	     dai=0d0
		 do L1=1,i1
	         i1L1=i1L1+1
               dai=dai-G(ifrp1(L1))*Z(i1L1)  ! (indm(i1,L1))
           enddo
	     i1L1=i1L1+i1
		 do L1=i1+1,Nfrp1
               dai=dai-G(ifrp1(L1))*Z(i1L1)  ! (indm(i1,L1))
	         i1L1=i1L1+L1
           enddo
		 da(i)=dai
		 akap=abs(dai)/sgm(i)
		 if(akap.gt.akappa) akappa=akap
	     pLi=pL(i)
!------------------CHECK FOR PARAMETERS ON BOUNDARY
 		 IF(amn(i).gt.-1d37) then
             If(dai.Le.0) then
		      pLi=min(pLi,(a(i)-amn(i)))
             Else
		      pLi=min(pLi,(amx(i)-a(i)))
             Endif
             If(pLi.Le.0.D0) then
                if(AKAP.gt.AFIX) then   
                   AFIX=AKAP   
                   memfix=I
                endif
		   Endif   ! end check 	      
           ENDIF  ! bounds
	     aLam=pLi/abs(dai)
	     if(aLam.lt.aLambd)aLambd=aLam
	     alams=alams+alam
        enddo   !------------------------ theor step to minimum
	  if(memfix.eq.0) exit  ! from boundary check cycLe
        mfix(memfix)=1
      enddo   !------------------ boundary check 

!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      ndf=ned1-Nfrp1+1
	hndf=hisq/ndf
	converg=dhisq/ndf
      IF(Nfrp1.eq.0) then
	   iflend=5
      ELSEIF(iit.ge.nitc) then
	   iflend=4
      ELSEIF(akappa.lt.eps) then
         If(iit.ne.0.or.hisqt.gt.1d36) then
	      iflend=1
	      if(Nfrp1.ne.Nfrp) iflend=2
         Endif
      ELSEIF(nn1.gt.n1) then
	   iflend=3
      ELSEIF(Nit.lt.0.and.iit.eq.1.and.hndf.gt.10.) then
	   iflend=4
      ELSEIF(converg.gt.-eps.and.iit.gt.15) then
	   iflend=3	   	 	  
      ENDIF

	IF(ifit.ne.0.and.iflend.ne.0) then
	   If(hisqm.gt.1.1*hisq) then 
	      iflend=0
	      hisqm=hisq
            hisqt=hisq/ned1*hisqmax(ifit)
	   Endif
	ENDIF
      oLdhisq=hisq
	alamo=alambd


      if(ip.gt.0)CALL MONITm(hnmin,a,ami,sgm,r,mfix,z,ifrp1,evset,hiset) 
 
      IF(iflend.ne.0) exit

!-----CALCULATE NEW CORRECTED STEP
	amb=0.25/aLambd
      do n=1,Nfrp
         i=ifrp(n)
	   If(mfix(i).eq.0) then
	      reL=abs(da(i))/pL(i)
	      DA(I)=DA(I)*ALAMBD
	      a(i)=a(i)+da(i)
	      if(NN2.gt.N2.and.aLambd.Lt.0.5d0) then !-------  increase pL(I)
               if(rel.gt.amb) PL(I)=PL(I)*4d0
            endif
         Else
	     mfix(i)=0
	     da(i)=0d0
         Endif
      enddo
      NN2=NN2+1

      Enddo    !  iiter=0, nitc
   
      do i=1,npar
         Ai(i,1)=a(i)
         Ai(i,2)=sgm(i)
         Ai(i,3)=R(i)
      enddo
	if(ip.gt.0.and.iit.ne.0)
     *call fumisave(Ai,exd,funct,z,pl,ifrp1,CH,hnmin,alm)

	ENDDO  ! ifit
	fumiLim=hndf
	hisqmax=0d0
	n1=0
	n2=0
	deaLLocate(mtrd,evset,hiset,alm)
      RETURN
                END ! FumiLim
                
			  Function ifumcomp(CH,h1)
      character*(*) CH, h1*1
	n=Len(CH)
	ifumcomp=0
	do i=1,n
	   if(h1.eq.CH(i:i)) then
	      ifumcomp=1
	      exit
         endif
      enddo
      RETURN
                END ! ifumcomp

                Function ifumread(ientr,CF,CH,ai,hnam1,hnmin)
!---------------  author: I.M. Sitnik, 2009
!---------------  read initial parameters from file
      IMPLICIT REAL*8 (A-H,O-Z)
      character*(*)CF,CH,hnam1(Np),hnmin*15(Np),s*1,namfil*19,exten*4(5)
	character*5 hfum,hfm
	common/fuminput/hisqmax(4),n1,n2/fumirs/ie,namfil(5)
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
      dimension ai(Np,6)
	data exten/'.fp0','.hi0','.cu0','.bp0','.ap0'/hfum/'fumi_'/

	ipr1=ifumcomp(CH,'f') ! each iteration print
	ip=6
	IF(CF.ne.'*') then
	   ip=301
	   open(ip,file=CF,err=4321,iostat=iostat)
4321     if(iostat.ne.0) then
            write(*,*)'FUMILIM: Wrong Output File Name'
	      ip=6
	   endif
	ENDIF
	write(ip,"(//2x'Fit',i4,'   by FUMILIM')") ientr
	IF(ientr.eq.1) then 
	write(ip,"(8x'Function value: chi^2/NDF (-1 for fatal end)')")
	write(ip,*) '       KAPPA: Estimated Distance to Minimum' 
      write(ip,*) '       LAMBDA: Step Length Modifier'
	ENDIF
	write(ip,"(' Iteration Limit:',i4)")nitc

      ifumread=0
	namfil=' '
	IF(hnam1(1).eq.'*') then
	   lnf=5
	   hfm=hfum
	   if(ientr.le.9) write(hfm(5:5),'(i1)') ientr
         namfil(1:5)(1:5)=hfm 
	   hnmin ='---------------'
      ELSE
	   hnmin =' '
	   len1=Len(hnam1(1))
	   if(Len1.gt.15) Len1=15
	   do i=1,len1
	      s=hnam1(1)(i:i)
	      if(s.eq.' '.or.s.eq.'.') exit
         enddo
	   lnf=i-1
	   namfil(1:5)(1:lnf)=hnam1(1)(1:lnf) 
         open(999,file=hnam1(1),status='old',err=3,iostat=iostat)
3        if(iostat.ne.0) then
            write(ip,'(/"        Initial Data File is Absent"/)')
	      do i=1,Np
	         Lenh=Len(hnam1(i))
	         if(Lenh.gt.15) Lenh=15
	         hnmin(i)(1:Lenh)=hnam1(i)(1:Lenh)
            enddo
         else
           write(ip,*) 'Initial Data File: ',hnam1(1)
	     do i=1,Np
	       read(999,*,err=4,end=4,iostat=iostat)
     *		   j,hnmin(i),ai(i,1),ai(i,4:6)
4	       if(iostat.ne.0) then
                write(ip,*)'*** Wrong Initial Data  File'
     *	      ,', line',i
	          ifumread=6 
                return
             endif
           enddo
	     read(999,*,end=1,iostat=iostat) hisqmax
1	     close(999)
         endif
	   Do i=1,Np
	      do j=15,1,-1
               if(hnmin(i)(j:j).ne.' ') exit
	         hnmin(i)(j:j)='-'
	      enddo	  			       
         Enddo
      ENDIF  
	ie=lnf+4
	namfil(1:5)(lnf+1:ie)=exten(1:5)

	return
	      end

            Function FUMI2par(Ai,exd,Lexd,nexd,funct,Nit)
!---------------  author: I.M. Sitnik, 2007
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL funct
	common/fumoutput/hisq,iflend,iit,akappa,aLambd,nbad
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/fum2par/A(2),PL(2),G(2),inddrv(2),z2(3),Nnodrv
      dimension mfix(2),sgm(2),DA(2),df(2),inddrvi(2)
	dimension exd(Lexd*nexd),Ai(2,6),ifrp(2),dummi(2)
      data eps/0.01d0/T/0.25/n1/4/n2/1/
      nitc=abs(Nit)
	ned1=nexd
	ned2=Lexd
	Nfrp=2
	a(1)=Ai(1,1)
	a(2)=Ai(2,1)
!----------------------------- find defined derivatives
      k=3
	is=0
	inddrvi(1)=0
	inddrvi(2)=0
	df(1)=0d0
	df(2)=0d0
	Nnodrv=0
      DO i=1,ned1
        h=funct(exd(k),a,df)
	  do j=1,Nfrp
	     if(df(j).ne.0d0) then
		   if(inddrvi(j).eq.0) then
		     inddrvi(j)=1
	         is=is+1
             endif 
           endif 
        enddo
	  if(is.eq.Nfrp) exit
	  k=k+ned2
      ENDDO
	if(is.ne.Nfrp) then
         do i=1,Nfrp
            if(inddrvi(i).eq.0) then
	        Nnodrv=Nnodrv+1
		    inddrv(Nnodrv)=i
            endif 
         enddo
      endif
!---------------------------- redefinition of pl(i)
	DO i=1,2
	   pL(i)=Ai(i,4)
	   if(pL(i).eq.0d0) then
	      if(inddrvi(i).ne.0) then
		     pL(i)=1d9
            eLse
	         d=0.01*abs(a(i))+1d-6
	         amem=a(i)
	         h=funct(exd(3),a,dummi)
	         a(i)=amem+d
	         h1=funct(exd(3),a,dummi)-h
	         a(i)=a(i)+d
	         h2=funct(exd(3),a,dummi)-h
	         a(i)=amem
	         f1=-0.5d0*(h2-4*h1)/d
	         f2=(h2-2d0*h1)/d**2
	         if(abs(f2).lt.1d-9) then
	             pl(i)=1d9
               else
	             pl(i)=abs(f1/f2)
               endif
		  endif
         endif
      ENDDO

      NN2=0
      iflend=0
	oldhisq=1d37
	alamo=1d0
      ndf=ned1-1
      DO iiter=0,nitc  !-----START NEW ITERATION
	   iit=iiter
!-----REPEAT ITERATION WITH SMALLER STEP
      do nn1=1,10   
	   caLL sgz2par(exd,funct)
	   hndf=hisq/ndf
	   dhisq=hisq-oldhisq
 	   if(nn1.gt.n1.or.iit.eq.0) exit
         if(dhisq.lt.0d0) exit
         NN2=0

         do i=1,2
 		  a(i)=a(i)-da(i)
            if(nn1.eq.1) PL(I)=PL(I)*T
            DA(I)=da(i)*T
            A(I)=A(I)+da(i)
         enddo
      enddo    ! nn1=1,n1 

      indef=mgconv2()
      IF(indef.ne.0) then
          fumi2par=-1.
	    write(*,*) 'ridiculous event'
	    iflend=5
	    return
      endif
!-----CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION
        aLambd=1d0
	  da(1)=-G(1)*Z2(1)-G(2)*Z2(2)
	  da(2)=-G(1)*Z2(2)-G(2)*Z2(3)
	  sgm(1)=sqrt(Z2(1))
	  sgm(2)=sqrt(Z2(3))
	  absda1=abs(da(1))
	  absda2=abs(da(2))
	  akappa=absda1/sgm(1)
	  akap2=absda2/sgm(2)
	  if(akap2.gt.akappa) akappa=akap2
	  AL1=pL(1)/absda1
	  if(AL1.lt.aLambd) aLambd=AL1
	  AL2=pL(2)/absda2
	  if(AL2.lt.aLambd) aLambd=AL2
	  IF(iit.eq.0.and.alambd.lt.0.5) then
	     if(aL1.gt.aL2) then
	        pl(1)=1.99/al1
	        pl(2)=1.99/al1
	        alambd=1.99/al1
           else
	        pl(1)=1.99/al2
	        pl(2)=1.99/al2
	        alambd=1.99/al2
	     endif
	     if(alambd.gt.1d0) alambd=1d0
        ENDIF

	 

!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      converg=dhisq/alamo/ndf
      IF(AKAPPA.Lt.EPS) then !  good finish
	   iflend=1
	ELSEIF(iit.eq.nitc) then
	   iflend=4
      ELSEIF(converg.gt.-eps.and.iit.gt.9) then !no futher decrease
         iflend=3
      ELSEIF(Nit.lt.0.and.iit.eq.1.and.hndf.gt.10.) then
	   iflend=4
      ENDIF

      IF(iflend.ne.0) exit
      amb4=aLambd*4d0
      IF(NN2.gt.N2) then
	   if(AL1.lt.amb4) pL(1)=pL(1)*4d0
         if(AL2.lt.amb4) pL(2)=pL(2)*4d0
      ENDIF
      da(1)=da(1)*aLambd
      da(2)=da(2)*aLambd
	a(1)=a(1)+da(1)
	a(2)=a(2)+da(2)
      oLdhisq=hisq
	alamo=alambd
      NN2=NN2+1

      ENDDO    !  iiter=0, nitc
      do i=1,2
        Ai(i,1)=a(i)
	  Ai(i,2)=sgm(i)
      enddo

      fumi2par=hndf
      RETURN
                END ! Fumi2par

	 Subroutine fumderiv(a,exd,funct,ifrp,mtrd,pl,hnm,amn,amx,alm)
!---------------  author: I.M. Sitnik, 2009
!--------------------------- separation of parameters, corellated with i-set
!--------------------------- adjust correct parameter step to find 1st derivatives
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp,mtrd,idrv
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
      common/Nparfum/np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	character*15 hnm(np),frm*80,hnl*2(3)
	dimension exd(ned1*ned2),alm(nxb,ns,2),xt(nx)
      dimension a(np),ifrp(Nfrp),amn(np),amx(np),pl(np),df(np)
	dimension dummi(np),idrv(np),idrvn(np),sumf1(np),sumf2(np),di(np)
	dimension mtd(Nfrp+1,ns),mtrd(Nfrp+1,ns),memj(np,ns)
	data frm/'(" Defined Derivatives:"i5"  of"i5" Free Parameters")'/
      data hnl/'  ','* ','**'/
	data pl2di/0.01d0/

	npl=0d0
      do n=1,Nfrp
	   i=ifrp(n)
	   df(i)=0d0
         sumf1(i)=0d0
	   sumf2(i)=0d0
	   idrv(i)=0
	   idrvn(i)=0
	   pli=pl(i)
	   if(pli.eq.0d0) then
	      npl=npl+1
	      if(amn(i).gt.-1d10.and.amx(i).lt.1d10) then
	         pli=0.5d0*(amx(i)-amn(i))
	      elseif(a(i).ne.0d0) then
	         pli=abs(a(i))
            else
	         pli=1d6
            endif
         endif
	   di(i)=pli*pl2di
      enddo
	    
	DO i=1,ns
	  mtrd(1,i)=0
	  mtd(1,i)=0
	  Do m=1,nxb
	     alm(m,i,1)=1d36
	     alm(m,i,2)=-1d36
	  Enddo
      ENDDO
	
	memj=0
	Ndertot=0
	Nondertot=0
	Ntot=0
      iset=1
	k=-ned2
      DO i=1,ned1
	   k=k+ned2
	   xt=exd(k+3:k+ned2)
	   if(ns.ne.1) iset=xt(nx)+0.5d0
	   Do m=1,nxb
	     if(xt(m).lt.alm(m,iset,1)) alm(m,iset,1)=xt(m)
	     if(xt(m).gt.alm(m,iset,2)) alm(m,iset,2)=xt(m)
         Enddo
         h=funct(xt,a,df)
	   IF(Ntot.ne.Nfrp) then
	      m=mtrd(1,iset)
	      m2=mtd(1,iset)
   	      do n=1,Nfrp
	         j=ifrp(n)
	         amem=a(j)
	         d=di(j)
	         a(j)=amem+d 
	         if(df(j).ne.0d0) then
	            if(idrv(j).eq.0) then
	               idrv(j)=1
	               Ndertot=Ndertot+1
                  endif
	            if(pl(j).eq.0d0) then
	               if(memj(j,iset).eq.0) then
	                  memj(j,iset)=1
	                  m2=m2+1
	                  mtd(m2+1,iset)=j
                     endif
                     h1=funct(xt,a,dummi)-h
	               f1=df(j)
				   f2=2d0*(h1-f1*d)/d**2	            
	               sumf1(j)=sumf1(j)+abs(f1)
	               sumf2(j)=sumf2(j)+abs(f2)
                  endif
	            df(j)=0d0
               else 
	            if(memj(j,iset).eq.0) then
                     h1=funct(xt,a,dummi)-h
	               if(h1.ne.0d0) then
	                  m=m+1
	                  mtrd(m+1,iset)=j
	                  memj(j,iset)=1
	                  if(idrvn(j).eq.0) then
                           idrvn(j)=1	          
			             Nondertot=Nondertot+1
                        endif
                     endif
                  elseif(pl(j).eq.0d0) then
                     h1=funct(xt,a,dummi)-h
	               a(j)=amem+2*d 
                     h2=funct(xt,a,dummi)-h
                     f1=0.5d0*(4*h1-h2)/d
	               f2=(h2-2*h1)/d**2
	               sumf1(j)=sumf1(j)+abs(f1)
	               sumf2(j)=sumf2(j)+abs(f2)
                  endif 
               endif
	         a(j)=amem
            enddo
	      mtrd(1,iset)=m
	      mtd(1,iset)=m2
	   ELSEIF(npl.ne.0) then
	      do n=1,mtd(1,iset)
	         j=mtd(n+1,iset)
               amem=A(j)
	         d=di(j)
               A(j)=Amem+d
		     h1=funct(xt,a,dummi)-h
	         f1=df(j)
			 f2=2d0*(h1-f1*d)/d**2	            
	         sumf1(j)=sumf1(j)+abs(f1)
	         sumf2(j)=sumf2(j)+abs(f2)
               A(j)=Amem
            enddo
	      do n=1,mtrd(1,iset)
	         j=mtrd(n+1,iset)
               amem=A(j)
	         d=di(j)
               A(j)=Amem+d
		     h1=funct(xt,a,dummi)-h
               A(j)=A(j)+d
               h2=funct(xt,a,dummi)-h
               f1=0.5d0*(4*h1-h2)/d
	         f2=(h2-2*h1)/d**2
	         sumf1(j)=sumf1(j)+abs(f1)
	         sumf2(j)=sumf2(j)+abs(f2)
               A(j)=Amem
            enddo
	   ENDIF
	   Ntot=Ndertot+Nondertot
	   if(npl.eq.0.and.Ntot.eq.Nfrp.and.nfit.eq.0) exit
      ENDDO  ! i=1,ned1

      if(ip.gt.0) then
	   write(ip,"(' Experim.Points:'i9', sets:'i6)")ned1,ns
	   write(ip,frm) Ndertot,Nfrp
         if(npl.gt.0) then
	      write(ip,"(//'  Adjusted Parameter Step Restriction')")
	      write(ip,"('  High Nonlinear Parameters are Marked')")
		  write(ip,"(25x'initial'5x'final'7x'ratio')")
         endif 
      endif 
      if(npl.gt.0) then
         do n=1,Nfrp
            j=ifrp(n)
	      if(pl(j).eq.0d0) then
			 pli=di(j)/pl2di
	         if(sumf2(j).ne.0d0) then
	            f2ev=sumf2(j)/ned1
		        plf=sumf1(j)/sumf2(j)*(idrv(j)+1)
	            if(di(j).eq.1d4.and.f2ev.gt.1d-11) plf=1d-1
               else  
	            plf=1d37
               endif
			 pl(j)=min(5*pli,plf)
		     r=pl(j)/pli
	         m=1
		     if(r.lt.0.1d0) m=2
		     if(r.lt.0.01d0) m=3
	         if(ip.gt.0) write (ip,"(i5,a16,1p3e12.3,a5)")
     *         j,hnm(j),pli,pl(j),r,hnl(m)
            endif
         enddo
	endif
      RETURN
                END ! Fumderiv

                   Function initfum(exd,a,amn,amx,ifrp,funct)
!---------------  author: I.M. Sitnik, 2007
!--------------- check of initial data
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	common/fuminput/hisqmax(4),n1,n2
	dimension exd(ned2*ned1)
	dimension a(Np),amn(Np),amx(Np),ifrp(Np),df(Np),xt(ned2-2)

 	initfum=0
	nfit=0
	nx=ned2-2
	if(n1.le.0) n1=3
	if(n2.le.0) n2=1
	it=ip
	if(it.le.0) it=6
	if(nitc.ne.0) then
	   do i=4,1,-1
	      if(hisqmax(i).gt.0d0.and.hisqmax(i).lt.1d36) then
	         nfit=i
	         exit
            endif
         enddo
      endif

	if(ned2.Lt.3) then
        write(it,"(//' Wrong Size of Exp.Point, Lexd=',i5)")ned2
        write(it,*) 'shouLd be Lexd>2'
	  initfum=6
      endif
	if((ned1-Nfrp).Lt.0) then
        write(it,'(//A22,i5,A37)')'Too Few Exp. Points =',
     &  ned1,'   should be at Least Nexd=N(free)par'
	  initfum=6
      endif
	if(initfum.ne.0) return

	do n=1,Nfrp
	   i=ifrp(n)
         if(amn(i).ge.amx(i)) then
		 write(it,'(//A20,i5,A18,1pe10.3,A5,e10.3)')
     &	 'Incorrect Bounds for',i,'th parameter: min=',
     &      amn(i),'max=',amx(i)
		 write(it,*) 'should be max > min'
		 initfum=6
	   endif	   
	   if(a(i).le.amn(i).or.a(i).ge.amx(i)) then !check ini-val within bounds
	      if(a(i).eq.0d0) then
	         a(i)=(amn(i)+amx(i))/2d0
		  else	  
		     write(it,"(i5'-th initial value is out of bounds range')") i
		     initfum=6
            endif
         endif
	enddo


	integx=nx-1
	nb=0 
	k=-ned2
      do i=1,ned1
	   k=k+ned2
	   if(exd(k+2).le.0d0) then
	     if(nb.eq.0)nb=i
	   endif
	   if(integx.ne.0) then
	      xl=exd(k+ned2)	    
	      iset=xl+0.5
	      if(abs(xl-iset).gt.1d-9.or.iset.lt.1) then
	         integx=0
            else 
	         if(iset.gt.ns) ns=iset
            endif
         endif
      enddo
	if(integx.eq.0) ns=1
	IF(ns.ne.1) then
	   Ndot=0
	   df=0d0
	   xt=exd(3:ned2)
	   h=funct(xt,a,df)
	   do n=1,Nfrp
	      j=ifrp(n)
	      if(df(j).eq.0d0) then
		     amem=a(j)
		     a(j)=amem+1d0
		     if(a(j).gt.amx(j)) a(j)=amx(j)  
	         df(j)=funct(xt,a,df)-h
	         a(j)=amem
            endif
	      if(df(j).ne.0d0) Ndot=Ndot+1
         enddo
	   if(Ndot.eq.Nfrp) ns=1
      ENDIF

	nxb=nx
	if(ns.ne.1) nxb=nx-1
	if(nfit.eq.0) nxb=0

	if(nb.gt.0) then
	  write(it,"(' Incorrect exda-array after',i8,'-th event')")nb
	  initfum=6
      endif 
	if(initfum.ne.0) then
         write(it,*)'*** Fatal Initial Conditions Errors'
	   return
      endif
	if(ns.ne.1.and.ip.gt.0)
     *  write(ip,"(' Free Param,/Exp.Point:',i5)") Ndot
	return
               END   ! initfum


      Subroutine SGZm(exd,funct,z,g,a,pl,amx,ifrp,mtrd,evs,hiset,alm)
!---------------   author: I.N. Silin
!---------------  upgrade: I.M. Sitnik, 2009
!-----Subroutine SGZ SETS UP CHI^2,G(GRADIENT OF S) AND
!-----Z(APPROXIMATE COVARIANCE MATRIX)
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp,mtrd
	common/nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	common/fumoutput/hisq,iflend,iit,akappa,aLambd,nbad
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	dimension z(nzfr),g(Np),a(Np),pl(Np),ifrp(Nfrp),amx(Np),df(Np)
      dimension dfn(Np),dummi(Np),HI(Np),mtrd(Nfrp+1,ns),x(nx)
	dimension exd(ned1*ned2),evs(ns),hiset(ns),alm(nxb,ns,2)

      hisq=0d0
	nbad=0
	evs=0d0
	hiset=0d0
	Z=0d0
	do i=1,Np
         g(i)=0d0
	   df(i)=0d0
           HIr=0.01d0*pl(i)
		 if((a(i)+HIr).gt.amx(i)) HIr=-HIr
		 HI(I)=HIr
      enddo

      K2=-ned2
	iset=1
      DO L1=1,ned1
         K2=K2+ned2
	   x=exd(k2+3:k2+ned)
         y=funct(x,a,df)
	   if(ns.ne.1) iset=x(nx)+0.5d0 
         SIG=exd(K2+2)
         dysig=(Y-exd(K2+1))/sig
	   hisqi=dysig**2+1d-36
         if(hisqi.gt.hisqt) then
	      mem=0
		  Do m=1,nxb
	         if(x(m).eq.alm(m,iset,1).or.x(m).eq.alm(m,iset,2)) mem=1
	      Enddo
	      if(mem.eq.0) then
	         nbad=nbad+1
               cycle
            endif
         endif
         hisq=hisq+hisqi
	   evs(iset)=evs(iset)+1d0
	   hiset(iset)=hiset(iset)+hisqi

	   Do n=1,mtrd(1,iset)
	      i=mtrd(n+1,iset)
            amem=A(I)
            A(I)=Amem+Hi(i)
		  DF(I)=(funct(x,a,dummi)-Y)/HI(i)
            A(I)=Amem
         Enddo
         L=0
	   jmin=0
         Do n=1,Nfrp
		  i=ifrp(n)
		  if(df(i).eq.0d0) then
		     DFn(n)=0d0
	         L=L+n
		  else
		     if(jmin.eq.0) jmin=n    
               DFt=DF(i)/SIG
               DFn(N)=DFt
               G(i)=G(i)+DFt*dysig
		     do j=jmin,n-1
                  Z(L+j)=Z(L+j)+DFt*DFn(j)
               enddo
	         L=L+n
	         Z(L)=Z(L)+dft**2
		     df(i)=0d0
		  endif
	   Enddo

      ENDDO !  L1=1,ned1
      RETURN
               END        ! sgzm

               Subroutine SGZ2par(exd,funct)
!---------------  author: I.M. Sitnik, 2007
!---------------  sgzopt for 2 parameters
      IMPLICIT REAL*8 (A-H,O-Z)
	common/fum2par/A(2),PL(2),G(2),inddrv(2),Z(3),Nnodrv
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/fumoutput/hisq,iflend,iit,akappa,aLambd,nbad
	dimension dummi(2),df(2),a2(2),hi(2),exd(ned1*ned2)
	externaL funct

      k=0
      hisq=0d0
	g(1)=0d0
	g(2)=0d0
      Z(1)=0d0
      Z(2)=0d0
      Z(3)=0d0
	hi(1)=pL(1)*0.01d0
	hi(2)=pL(2)*0.01d0

      DO L1=1,ned1
         SIG=exd(k+2)
	   y=funct(exd(k+3),a,df)
         dysig=(Y-exd(k+1))/sig
	   hisq=hisq+dysig**2
	   do n=1,Nnodrv
	      i=inddrv(n)
		  AI=A(i)
            A(i)=AI+HI(i)
		  df(i)=(funct(exd(k+3),a,dummi)-Y)/HI(i)
            A(i)=AI
         enddo

	   df1=df(1)/sig
	   df2=df(2)/sig
         G(1)=G(1)+df1*dysig
         G(2)=G(2)+df2*dysig
         Z(1)=Z(1)+df1*df1
         Z(2)=Z(2)+df1*df2
         Z(3)=Z(3)+df2*df2
         k=k+NED2
      ENDDO !  L1=1,ned1

      RETURN
           END

         Subroutine MONITm(hoL,a,ai,sig,r,mfix,z,ifrp1,evset,hiset)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2009
!-----ITERATION PROGRESS OUTPUT
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp1,mfix
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	common/fumoutput/hisq,iflend,iit,akp,aLam,nbad
	dimension a(Np),ai(Np),sig(Np),r(Np),ifrp1(Nfrp1)
	dimension mfix(Np),ir(Np),z(Nzfr),evset(ns),hiset(ns)
	character*(*) hoL(Np),zv*4,zvi*2(2),ht*51(5)
	character*9 hpar,hpr(2),hdev,hch,hsta*8,hcor*11   
	data hpar/'Parameter'/,hsta/'Standard'/,hcor/'Max.Pair'/
	character*13 hnum,hval*5,hfac*12,hfor*80(4)
	data hnum/'Number & Name'/,hval/'Value'/,hdev/'Deviation'/
	data hfac/'Correl.Fact.'/,hch/'Increment'/
	data ht/' Full Success',
     *' Success When Some Parameters are Fixed by FUMILIM ',
     *' Minimization is Terminated, No Further Convergence',
     *' Minimization is Terminated, Iteration Limit',
     *' Minimization is Terminated, No Free Parameters'/
	data hfor(1)
     */"(I7,a16,1pD14.5,A2,D13.5,D14.5,0p' ('f5.1'%)'A2,f8.3,i5,A6)"/      
      data hfor(2)/"(I7,a16,1pD16.5,7x'Fixed on Bound')"/
      data hfor(3)/"(I7,a16,1pD16.5,8X'Fixed: dF/dA=0')"/
      data hfor(4)/"(I7,a16,1pD16.5,6X'Fixed by User')"/
	data zvi/' *','  '/

      hndf=hisq/(ned1-Nfrp1+1)
      write(ip,'(/A8,I3,A13,1pD12.5,A9,D12.5,A13,D9.2,A8,D9.2)')
     *'Iter=',iit,':  chi^2/NDF=',
     *hndf,'chi^2=',hisq,'KAPPA=',akp,'LAMBDA=',aLam
	if(nbad.ne.0) then
	  percent=100d0*nbad/ned1
	  write(ip,'(i7"("f4.1"%)"A40)')nbad,percent,
     &  ' events are ignored due to huge chi^2'
	endif
	if(iit.eq.0) hndf0=hndf
	IF(iflend.ne.0.or.ipr1.eq.1.or.iit.eq.0) then
	   write(ip,'(/A15,A20,A14,A15,A27)')hpar,hpar,hsta,hpar,hcor
	   write(ip,'(A19,A12,A19,A14,A28/)')hnum,hval,hdev,hch,hfac
         call fumcormax(z,ifrp1,r,ir)
         izv=2
	   DO I=1,Np
	      izv=3-izv
            ipr=mfix(i)+1
	      If(ipr.eq.1) then
	         da=a(i)-ai(i)
	         if(da.eq.0d0) then
	            per=0d0
               else
		        den=max(abs(a(i)),abs(ai(i)))
			    per=abs(da)/den*100
		     endif
			 zv='    '
			 if(abs(r(i)).gt.0.9) zv='>0.9'
	         write(ip,hfor(ipr)) I,hoL(i),A(I),zvi(izv),
     *		 sig(I),da,per,zvi(izv),R(i),ir(i),zv
	      Else	 
	         write(ip,hfor(ipr)) I,hoL(i),A(I)
            Endif
	   enddo
      ENDIF

      IF(iflend.eq.0) return
	write(ip,'(/"Iflend=",I2,":",a51/)')iflend,ht(iflend)
	write(ip,"('chi^2/NDF change:'1pd12.5,'  ->'d12.5)")hndf0,hndf
	IF(ns.ne.1) then
	   write(ip,'(/"Exp.points ,<chi^2> for each set")')
	   rat=hisq/ned1
         write(ip,'("  All",i9,1pe12.3)') ned1, rat
	   do i=1,ns
            if(evset(i).ne.0d0) then
	         rat=hiset(i)/evset(i)
	         n=evset(i)
	         write(ip,'(i5,i9,1pe12.3)') i, n, rat
            endif 
         enddo
      ENDIF
	return
               END

               Function mgconv2()
!---------------  author: I.M. Sitnik, 2007
!---------------  Z-matrix transformation for 2 parameters
      IMPLICIT REAL*8 (A-H,O-Z)
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/fum2par/A(2),PL(2),G(2),inddrv(2),z(3),Nnodrv

      mgconv2=0
      zm1=Z(1)
      zm2=Z(2)
	zm2q=zm2**2
	zm3=Z(3)
	if(zm1.Le.0d0.or.zm3.Le.0d0) then
	   mgconv2=2
	   return
      endif 

      det=zm3-zm2q/zm1
	if(det.Le.1d-19) det=1d-19
	z(3)=1d0/det
      z(1)=1d0/zm1+zm2q/zm1**2*z(3)
	z(2)=-zm2/zm1*z(3)
	RETURN
                      end

               Subroutine fumcormax(Z,ifrp,r,icor)
!------------  author: I.M. Sitnik, 2010
!-----calculate pair corellations between parameters
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifrp
	common/nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	dimension Z(Nzfr),ifrp(Nfrp1),r(Np),icor(Np)

	nn=0
      DO n=1,Nfrp1
	   nn=nn+n
	   mm=0
	   z1=Z(nn)
	   cormax=0d0
	   mem=0
	   mnn=n*(n-1)/2
	   Do m=1,n-1
	      mn=mnn+m
	      mm=mm+m
	      z2=Z(mn)
	      if(z2.eq.0d0) cycle
	      r1=z2/sqrt(Z(mm)*z1)
	      if(abs(r1).gt.abs(cormax)) then
	         cormax=r1
	         mem=ifrp(m)
	      endif
	   Enddo
	   mm=nn
	   mn=n*(n+1)/2+n
	   Do m=n+1,Nfrp1
	      mm=mm+m
	      z2=Z(mn)
	      mn=mn+m
	      if(z2.eq.0d0) cycle
	      r1=z2/sqrt(Z(mm)*z1)
	      if(abs(r1).gt.abs(cormax)) then
	         cormax=r1
	         mem=ifrp(m)
	      endif
         Enddo
	   i=ifrp(n)
	   icor(i)=mem
	   r(i)=cormax
      ENDDO
	RETURN
                end

           Subroutine fumisave(Ai,exd,funct,z,pl,ifrp1,CH,hnam2,alm)
!---------------  author: I.M. Sitnik, 2010
!-----writes output files
!-----HNAME.fpN (fitted parameters) 
!-----HNAME.apN (all points).
!-----HNAME.bpN (bad points)
!-----HNAME.cuN (curve)
!-----HNAME.hiN (chi^2-distribution)

      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(nstep=100)
	integer*2 ifrp1
	character*(*)CH,namfil*19,hnam2*15(Np),s*1,hx*5,f1*59,f2*25
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/Nparfum/Np,Nfrp,Nfrp1,Nzfr,Ndertot,nitc
	common/fuminput/hisqmax(4),n1,n2/fumirs/ie,namfil(5)
	common/fumoutput/hisq,iflend,iit,akappa,aLambd,nbad
	common/fumx/x(20),ix
	dimension exd(ned2,ned1),pL(Np),ifrp1(Np),df(Np),dummi(Np)
	dimension a(Np),dfn(Np),z(Nzfr),ai(Np,6),ar(nstep,2)
	dimension alm(nxb,ns,2),xt(20)
	data hx/'x(  )'/f2/'(I5,1p3e12.3,3x,2e12.3)'/f1
     */'(2x"N"7x"Y_th"6x"err_th"5x"(exp-th)/sig",A10,7x,"x(Last)")'/
!---------------------------
	do i=0,9
	   write(s,'(i1)') i
         namfil(1)(ie:ie)=s
	   open(999,file=namfil(1),status='old',err=5,iostat=iostat)
5        if(iostat.ne.0) exit
      enddo
	if(iostat.eq.0) s='_'
	namfil(1:5)(ie:ie)=s
	open(99,file=namfil(1))
	do i=1,Np
	  write(99,'(i6,3x,A15,3x,1p4E13.4)')i,hnam2(i),Ai(i,1),Ai(i,4:6)
      enddo
	if(hisqmax(1).ne.0d0) write(99,'(/4f10.2)') hisqmax
	close(99)
      write(ip,'(/"Fitted Parameters are Saved to  ",a19)')namfil(1)
	if(CH.eq.'*') return
      ma=ifumcomp(CH,'a')
	mb=ifumcomp(CH,'b')*nbad
	mh=ifumcomp(CH,'h')
	mc=ifumcomp(CH,'c')
	mab=ma+mb
	mabh=mab+mh
	ms=mabh+mc
	if(ms.eq.0) return
      a=ai(1:Np,1)
	nx=ned2-2
	if(ned2.eq.3) then
	   ix=1
      else
	   if(ix.eq.0) then
	      ix=1
	      x(1:nx)=exd(3:ned2,1)
	   endif
	endif
	if(ix.le.9) then
	   write(hx(4:4),'(i1)') ix
      else
	   write(hx(3:4),'(i2)') ix
      endif

      alimh=1d37
	blimh=1d-36    
      alimc=1d37
	blimc=-1d37    

      if(mb.ne.0) then
	   open(98,file=namfil(4))
	   write(98,f1) hx
	   write(ip,'("Bad Points are Saved to ",a19)')namfil(4)
	endif
      if(ma.ne.0) then
	   open(99,file=namfil(5))
	   write(99,f1) hx
	   write(ip,'("All Points are Saved to ",a19)')namfil(5)
	endif

      iset=1
      DO j=1,ned1
	   xt(1:nx)=exd(3:ned2,j)
         xc=xt(ix)
	   if(xc.lt.alimc) alimc=xc
	   if(xc.gt.blimc) blimc=xc
	   if(mabh.eq.0) cycle
         SIG=exd(2,j)
	   if(ns.ne.1)iset=xt(nx)
	   df=0d0
	   y=funct(xt,a,df)
         IF(mab.ne.0) then
	      do n=1,Nfrp1
               i=ifrp1(n)
	         if(df(i).eq.0d0) then
                  Amem=A(I)
                  HI=0.01D0*pL(I)
                  A(I)=Amem+HI
		        DF(I)=(funct(xt,a,dummi)-Y)/HI
                  A(I)=Amem
               endif
		     dfn(n)=df(i)
            enddo
            erf=scaLm(z,dfn,Nfrp1)
         ENDIF  
	   dif=(exd(1,j)-y)/sig
	   hsq=dif**2+1d-36
	   if(hsq.lt.alimh)alimh=hsq
	   if(hsq.gt.blimh)blimh=hsq
	   if(hsq.gt.hisqt.and.mb.ne.0) then
	      do m=1,nxb
	         if(xt(m).ne.alm(m,iset,1).and.xt(m).ne.alm(m,iset,2))
     *         write(98,f2)j,y,erf,dif,xt(ix),xt(nx)
	      enddo
	   endif
	   if(ma.ne.0) write(99,f2)j,y,erf,dif,xt(ix),xt(nx)
      ENDDO

      IF(mh.eq.1) then    !----------------- chi^2/<chi^2>
          
         ar=0d0
         avh=hisq/ned1
	   open(999,file=namfil(2))
	   write(999,"(3x'lg(hi^2)     hi^2<max   hi^2>max')") 
	   na=log10(alimh/avh)-1
	   if(na.lt.-4) na=-4
	   nb=log10(blimh/avh)+1
	   step=1d0*(nb-na)/(nstep-1)
	   ar=0d0

         do m=1,ned1
            y=funct(exd(3,m),a,df)
            dysig=(exd(1,m)-Y)/exd(2,m)
	      hsq=dysig**2+1d-36
	      hsqlog=log10(hsq/avh)-na
	      j=hsqlog/step+1
	      ind=1
	      if(hsq.gt.hisqt) ind=2
	      if(j.gt.0) ar(j,ind)=ar(j,ind)+1d0
         enddo !  m=1,ned1

	   arg=na-0.5d0*step
         do i=1,nstep
	     arg=arg+step
           write(999,'(1p3e12.3)') arg, ar(i,1:2)
	   enddo
	   write(ip,'("lg(hi^2)-histogram is Saved to ",a19)')namfil(2)
      ENDIF
	
	IF(mc.eq.1) then         !------------------- curve 
	   dlim=(blimc-alimc)
	   dlim1=dlim*0.1d0
	   alimc=alimc-dlim1
	   blimc=blimc+dlim1
	   dx=(bLimc-aLimc)/(nstep-1)

         open(999,file=namfil(3))
	   write(999,"(7x'x             y          y-err       y+err')") 
         Do j=1,nstep
	      x(ix)=aLimc+(j-1)*dx
	      df=0d0
	      y=funct(x,a,df)
          
            do n=1,Nfrp1
               i=ifrp1(n)
	         if(df(i).eq.0d0) then
                  Amem=A(I)
                  HI=0.01D0*pL(I)
                  A(I)=Amem+HI
		        DF(I)=(funct(x,a,df)-Y)/HI
                  A(I)=Amem
               endif
		     dfn(n)=df(i) 
            enddo

            er=scaLm(z,dfn,Nfrp1)
	      dw=y-er
	      up=y+er
	      write(999,'(1pe12.3,3x,3e12.4)') x(ix),y,dw,up
         Enddo
         write(ip,'("Theor-Curve is Saved to ",a19)')namfil(3)
      ENDIF
	close(99)
	if(mb.ne.0) close(98)
      RETURN
                     END

               Function SCALm(Z,df,n)
!--------------- Calculate Er-Variance of Theoretical Function Y
!---------------  author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2009
      IMPLICIT REAL*8 (A-H,O-Z)
	dimension Z(*),df(n)
 
	dispii=0d0
	dispij=0d0
	m=0
      DO I=1,N
         Do L=1,I-1
	      m=m+1
            dispij=dispij+Z(m)*DF(I)*DF(L)
         Enddo
	   m=m+1
	   dispii=dispii+Z(m)*DF(I)**2
      ENDDO
	disp=dispii+2d0*dispij
      scaLm=sqrt(disp)
      RETURN
              END

			Function fstrawd(x,a,df)
!---------------  author: I.M. Sitnik, 2007
!--------------- InternaL Function for Tracks via Straws

	impLicit reaL*8(a-h,o-z)
      dimension x(2),a(2),df(2)

      up=a(1)*x(1)+a(2)-x(2)
	dw=1d0+a(1)**2
	f=abs(up)/sqrt(dw)+1d-19
	up1=up*(dw*x(1)-a(1)*up)

	dw2=dw*f
	dw1=dw2*dw
	df(1)=up1/dw1
	df(2)=up/dw2

      fstrawd=f
	return
			end
	        Function fumstraw(as,bs,exd,nex)
!---------------  author: I.M. Sitnik, 2007
!---------------  user call for for tracks via straws
	impLicit reaL*8(a-h,o-z)
	dimension ast(2),bst(2),hi(2),exd(*),ex(nex)
	ex=0d0
	ir=ifumstraw(ast,bst,hi,exd,nex,1d0,0d0,ex)
	as=ast(1)
	bs=bst(1)
	fumstraw=hi(1)
	return
	         end
	        Function ifumstraw(as,bs,hs,exd,nex,rh,dh,ex)
!---------------  author: I.M. Sitnik, 2007
!--------------- user caLL for tracks via straws x=as*z+bs
!--------------- chndf=fumstraw(as,bs,exd), where
!                    exd : input array of experimentaL points
!                    exd(1,i): space radius (not time)
!                    exd(2,i): error  
!                    exd(3,i): z-coordinate of wire (aLong track) 
!                    exd(4,i): x-coordinate of wire (transversaL to z)
!                    shouLd be the same units for exd(1:4,i)
!                    nex: number of experimentaL poits
!                    as(1:2): angle coefficient    
!                    bs(1:2): space coefficient    
!                    hi(1:2): chi^2
!   z-coordinate of 1st exp-point shouLd be Least, and of Last exp-point shouLd be Largest of vice versa  

	impLicit reaL*8(a-h,o-z)
	parameter(Lexd=4)
      dimension exd(Lexd,nex),hisq(4),ab(2,6,4),as(2),bs(2),hs(2)
	dimension ex(nex),rmem(nex),a2s(2)
	externaL fstrawd

	x1=exd(3,1)
	dx=exd(3,nex)-x1
	y1=exd(4,1)
	dy=exd(4,nex)-y1
	r1=exd(1,1)
      r2=exd(1,nex)
	dxq=dx**2
	dyq=dy**2
	dxdy=dx*dy
!--------------------- make 4 sets of initiaL vaLues of parameters   
      c=r1+r2
	cq=c**2
	det=dxq+dyq-cq
	absdet=abs(det)+1d-37
	sqdet=sqrt(absdet)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,1)=a1
	ab(1,1,2)=a2
	ab(2,1,1)=y1-a1*x1-r1*sqrt(1.+a1**2)
	ab(2,1,2)=y1-a2*x1+r1*sqrt(1.+a2**2)
	ab(1,4,1)=0.5d0
	ab(1,4,2)=0.5d0
	ab(2,4,1)=10.5d0
	ab(2,4,2)=10.5d0

      c=r2-r1
	cq=c**2
	det=dxq+dyq-cq
	sqdet=sqrt(det)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,3)=a1
	ab(1,1,4)=a2
	ab(2,1,3)=y1-a1*x1+r1*sqrt(1.+a1**2)
	ab(2,1,4)=y1-a2*x1-r1*sqrt(1.+a2**2)
	ab(1,4,3)=0.5d0
	ab(1,4,4)=0.5d0
	ab(2,4,3)=10.5d0
	ab(2,4,4)=10.5d0
!---------------------------------------end of make.....
      do i=1,4
	   hisq(i)=fumi2par(ab(1,1,i),exd,Lexd,nex,fstrawd,-10)
	enddo
      hisqm=hisq(1)
	mbest=1
	hisq2=1d37
	do i=2,4
         if(hisq(i).Lt.hisqm) then
	      mb2=mbest
	      hisq2=hisqm
		  mbest=i
	      hisqm=hisq(i)
         elseif(hisq(i).Lt.hisq2) then
            mb2=i
		  hisq2=hisq(i)
         endif
      enddo
	mtr=1
	hs(1)=hisqm
      as(1)=ab(1,1,mbest)
	bs(1)=ab(2,1,mbest)

	if(dh.gt.0d0) then
	   hs(2)=hisq(mb2)
         as(2)=ab(1,1,mb2)
	   bs(2)=ab(2,1,mb2)
	   rat=hisq2/hisqm
	   dif=hisq2-hisqm
	   if(rat.lt.rh.or.dif.lt.dh) then
	      da=abs(as(2)-as(1))
	      if(da.gt.1d-4) mtr=2
         endif
      endif
	ifumstraw=mtr
	if(ex(1).eq.0d0) return
	alf=atan(as(1))
	a2s(1)=as(1)
	a2s(2)=bs(1)
	do i=1,nex
	   rmem(i)=exd(1,i)
	   dx=as(1)*exd(3,i)+bs(1)-exd(4,i)
	   if(dx.gt.0d0) then
	      bet=-alf
         else
	      bet=alf
         endif
	   exd(1,i)=exd(1,i)*(1d0+ex(i)*cos(bet)) 
	enddo
      hs(1)=fumi2par(a2s,exd,Lexd,nex,fstrawd,10)
	exd(1,1:nex)=rmem	     
	return
	         end

               Function mgconvm(z,mfix,ifrp1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2009
!---------------  Z-matrix transformation
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(rp=1d-17,ap=1d-37)
 	integer*2 ifrp1,mfix
	common/gLofum/hisqt,ned1,ned2,ip,ipr1,ns,nfit,nx,nxb
	common/nparfum/Np,Nfrp,N,Nzfr,Ndertot,nitc
	dimension z(nzfr),mfix(Np),ifrp1(N),r(Np)
	dimension km(N),ind1i(N),indii(N)

      mgconvm=0
	if(N.eq.0) return
	APS=1./(ap*N)
      APn=1./APS
      APS=SQRT(APS)
	II=0
	m=1
	iz=0
      DO I=1,N
 	  ind1i(i)=m
        m=m+i
	  indii(i)=m-1
        R(I)=MAX(Z(m-1),APn)
      ENDDO ! i=1,n
	nn=indii(n)-n

      DO j=1,n
        zcmi=aps
        km(j)=j
        kk=0
        Do k=j,n
            zndmk=0.
            kk=kk+k
            zdk2=MAX(z(kk),RP*ABS(R(k)),rp*abs(z(kk)),APn)
            zdk=sqrt(zdk2)
	      kL=indii(k)-k+j
            do L=j+1,k-1
	         kL=kL+1 
               if(abs(z(kL)).ge.zndmk) zndmk=abs(z(kL))
            enddo ! L=1,n
	      kL=indii(k)+k
            do L=k+1,n
               if(abs(z(kL)).ge.zndmk) zndmk=abs(z(kL))
	         kL=kL+L
            enddo ! L=1,n
            if(zndmk/zdk.Lt.zcmi) then
	      zcmi=zndmk/zdk
              km(j)=k
            endif
            i=km(j)
        Enddo ! k=1,n

        if(i.ne.j) then ! exchange i-th and j-th strings and coLumns of matrix
          ii=indii(i)
          jj=indii(j)
          sav=z(ii)
	    z(ii)=z(jj)
          z(jj)=sav
	    ki=ind1i(i)
	    kj=ind1i(j)
          do k=1,j-1
             sav=z(ki)
             z(ki)=z(kj)
             z(kj)=sav
	       ki=ki+1
	       kj=kj+1
          enddo ! k=1,n
          kj=kj+J
          do k=j+1,i-1
	       ki=ki+1
             sav=z(ki)
             z(ki)=z(kj)
             z(kj)=sav
	       kj=kj+k
          enddo ! k=1,n
          kj=kj+i
          ki=ki+i+1
          do k=i+1,n
             sav=z(ki)
             z(ki)=z(kj)
             z(kj)=sav
	       ki=ki+k
	       kj=kj+k
          enddo ! k=1,n
 
          ri=r(i)
          r(i)=r(j)
	    r(j)=ri
        endif ! i.ne.j
        i=j
        ii=indii(i)
        rpn=max(rp*abs(r(i)),rp*abs(z(II)),apn) !

        IF(Z(II).LE.RPn) then
          Z(II)=RPn
          R(I)=-ABS(R(I))
          mfix(ifrp1(i))=2
	    mgconvm=1
        endif
        z(ii)=1./sqrt(z(ii))
        arp=aps/z(ii) !qz(i,i)
        DM=1.
        am=1.
	  iL=ind1i(i)
        Do L=1,i-1
           ZiL=ABS(Z(iL))
           IF(ZiL.GT.ARP) DM=ARP/ZiL
           IF(AM.GT.DM) AM=DM
	     iL=iL+1
        Enddo ! L=1,n
	  iL=iL+i
        Do L=i+1,N
           ZiL=ABS(Z(iL))
           IF(ZiL.GT.ARP) DM=ARP/ZiL
           IF(AM.GT.DM) AM=DM
	     iL=iL+L
        Enddo ! L=1,n

        Z(II)=Z(II)*AM
	  iL=nn+i
        Do L=n,i+1,-1
           Z(iL)=Z(iL)*Z(II)
	     iL=iL-L+1
        Enddo ! L=n,1,-1
        Do L=i-1,1,-1
	     iL=iL-1
           Z(iL)=Z(iL)*Z(II)
        Enddo ! L=n,1,-1
	  ki=nn+i
	  Do k=n,i+1,-1
          C=Z(Ki) ! *qZ(I,I)
	    Lk=indii(k)
	    Li=Lk-k+i
          do L=k,i+1,-1 ! reaL z(n,i) - z(k+1,i) now are zeros
             Z(Lk)=Z(Lk)-Z(LI)*C
	       Lk=Lk-1
	       Li=Li-L+1
          enddo ! L=n,1,-1
          do L=i,1,-1 ! reaL z(n,i) - z(k+1,i) now are zeros
             Z(Lk)=Z(Lk)-Z(LI)*C
	       Lk=Lk-1
	       Li=Li-1
          enddo ! L=n,1,-1
          Z(Ki)=-C*z(ii) ! -C
          ki=ki-k+1
        Enddo ! k=n,i+1,-1
      ENDDO ! j=1,n

      DO I=1,N
	   ii=indii(i)
         D=z(II)**2
	   Li=ii+i
	   ki=LI
         Do L=I+1,n
            D=D+Z(Li)**2
	      Li=Li+L
         Enddo ! L=k,n
         Z(II)=D
         Do K=I+1,n
	      kk=indii(k) 
            D=z(ki)*z(kk)
	      Lk=kk+k
	      Li=ki+k
            do L=k+1,n
               D=D+Z(Li)*Z(Lk)
	         Lk=Lk+L
	         Li=Li+L
            enddo ! L=k,n   !------------------ end cLuster
            Z(ki)=D
            ki=ki+k
         Enddo ! k=i,n
      ENDDO ! i=1,n  

      DO i=n,1,-1
        j=km(i)
        if(j.ne.i) then ! Exchange i-th and j-th strings and coLumns of matrix
           ii=indii(i)
           jj=indii(j)
	     sav=z(ii)
           z(ii)=z(jj)
           z(jj)=sav

           ki=ind1i(i)
           kj=ind1i(j)
	     Do k=1,i-1
              zki=z(ki)
              z(ki)=z(kj)
	        z(kj)=zki
	        ki=ki+1
	        kj=kj+1
           Enddo ! k=1,n
           ki=ki+i
           Do k=i+1,j-1
              kj=kj+1 
              zki=z(ki)
              z(ki)=z(kj)
	        z(kj)=zki
              ki=ki+k 
           Enddo ! k=1,n
           ki=ki+j
	     kj=kj+j+1 
           Do k=j+1,n
              zki=z(ki)
              z(ki)=z(kj)
	        z(kj)=zki
	        ki=ki+k
	        kj=kj+k
           Enddo ! k=1,n
        endif ! j.ne.i
      ENDDO ! i=n,1,-1

      RETURN
      end
